/*	(C) Copyright 1991 Dave Fritsche (wb8zxu), All Rights Reserved.
 * 
 *	Redistribution and use in source and binary forms are permitted for
 *	non-commercial use, provided that the above copyright notice and this
 *	paragraph are duplicated in all such forms.  THIS SOFTWARE IS PROVIDED
 *	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 *	WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND
 *	FITNESS FOR A PARTICULAR PURPOSE.
 */
#include <stdio.h>
#include "screen.h"

mk_info()
{
	FILE *info;
	unsigned char buf[128];

	sprintf(buf, "%s\\spool\\help\\info.hlp", path);
	if (debug)
	{
		printf("***> info.hlp file (%s):\n", buf);
		info = stdout;
	}
	else
		if ( (info = fopen(buf, "w")) == NULL )
		{
			printf("\nCan't open \"%s\" for write, aborting!\n\n", buf);
			exit(-1);
		}

	fprintf(info, "Welcome to %s's TCP/IP system\n", callsign);
	fprintf(info, "\n");
	fprintf(info, "The software running on this machine is the TCP/IP software package developed\n");
	fprintf(info, "by Phil Karn, KA9Q  called NOS.  It is freely  available including \"C\" source\n");
	fprintf(info, "code.  If you  have  access to  \"Internet\", you can ftp the latest \"snapshot\"\n");
	fprintf(info, "of Phil's work from thumper.bellcore.com.  You can of  course also get a copy\n");
	fprintf(info, "directly  from me.  It is also possible to download a copy of NOS directly by\n");
	fprintf(info, "using the \"DU\" form of the  download  command (use \"help download\" for info).\n");
	fprintf(info, "This is not encouraged, as it is a large file (approx 150K) and will tie up a\n");
	fprintf(info, "slow, local packet channel for quite a long time.\n");
	fprintf(info, "\n");
	fprintf(info, "The system here is composed of:\n");
	fprintf(info, "\n");
	fprintf(info, "          Computer:  IBM-PC or compatible\n");
	if (com1)
		fprintf(info, "   Radio Interface:  Serial port COM1, interface name \"ax1\", %ld baud\n", com1spd);
	if (com2)
		fprintf(info, "   Radio Interface:  Serial port COM2, interface name \"ax2\", %ld baud\n", com2spd);
	if (com3)
		fprintf(info, "   Radio Interface:  Serial port COM3, interface name \"ax3\", %ld baud\n", com3spd);
	if (com4)
		fprintf(info, "   Radio Interface:  Serial port COM4, interface name \"ax4\", %ld baud\n", com4spd);
	if (drsi_0)
		fprintf(info, "   Radio Interface:  DRSI PCPA, interface name \"da0\", %ld baud\n", drsi_0spd);
	if (drsi_1)
		fprintf(info, "   Radio Interface:  DRSI PCPA, interface name \"da1\", %ld baud\n", drsi_1spd);
	if (pc100_0)
		fprintf(info, "   Radio Interface:  Paccomm PC-100, interface name \"pa0\", %ld baud\n", pc100_0spd);
	if (pc100_1)
		fprintf(info, "   Radio Interface:  Paccomm PC-100, interface name \"pa1\", %ld baud\n", pc100_1spd);
	fprintf(info, "\n");
	fprintf(info, "Leave mail for the owner of this system by using the command:\n");
	fprintf(info, "   S %s\n", callsign);
	fprintf(info, "\n\n");

	if (!debug)
		fclose(info);
}
